
DefSng R-Z

'Multi-Output-Deklarationen
Dim Shared Mflag As Integer         'Outputflag
Dim Shared Monochrome As Integer    '1 = Schwarz/Weiss
Dim Shared hfont                    'aktuelles Font-Handle
Dim HoldFont%, Holdalign%           'Handle zum vorigen Font u. Align, fr RestoreFont
Dim Shared PrinterHfont             'aktuelles Font-Handle
Dim PrinterHoldFont%, PrinterHoldalign%           'Handle zum vorigen Font u. Align, fr RestoreFont

'Font-Deklarationen
Type Textmetric
    tmHeight As Integer
    tmAscent As Integer
    tmDescent As Integer
    tmInternalLeading As Integer
    tmExternalLeading As Integer
    tmAveCharWidth As Integer
    tmMaxCharWidth As Integer
    tmWeight As Integer
    tmItalic As String * 1
    tmUnderlined As String * 1
    tmStruckOut As String * 1
    tmFirstChar As String * 1
    tmLastChar As String * 1
    tmDefaultChar As String * 1
    tmBreakChar As String * 1
    tmPitchandFamily As String * 1
    tmCharset As String * 1
    tmOverhang As Integer
    tmDigitizedAspectX As Integer
    tmDigitizedAspectY As Integer
End Type


Declare Function ExtFloodFill Lib "GDI" (ByVal hdc As Integer, ByVal x As Integer, ByVal y As Integer, ByVal crColor As Long, ByVal wFillType As Integer) As Integer
Declare Function GetDeviceCaps Lib "GDI" (ByVal hdc As Integer, ByVal nIndex As Integer) As Integer

Declare Function GetTextFace Lib "GDI" (ByVal hdc As Integer, ByVal nCount As Integer, ByVal lpFacename As String) As Integer
Declare Function GetTextMetrics Lib "GDI" (ByVal hdc As Integer, lpMetrics As Textmetric) As Integer
Declare Function SetTextAlign Lib "GDI" (ByVal hdc As Integer, ByVal fuAlign As Integer) As Integer

Sub a_Document_MULTOUT ()
'Graf. Ausgabe wahlweise nach Picturebox Pic (0), Metafile (2) oder Printer (1)
'Die Einstellungen fr ForeColor, DrawStyle, FillStyle, FontName, FontType..
'werden von der Picturebox Pic bernommen


'BSP:
'nach Pic:
'----------
'   MsetOutput 0, Pic
'   .... Mline, MCircle, MPrint.....



'nach Metafile
'--------------
'     BeginMetaFile MFName$, xmin!, ymin!, xmax!, ymax!, MapMode%
'     MsetOutput 2, Pic
'   .... Mline, MCircle, MPrint.....
'     EndMetafile Flag2

'MapMode%:  8=MM_ANISOTROPIC    (vernderbare Grsse)
'           3=MM_HIMETRIC       (mm exact, max. 320 mm, Grsse fest)
'           2=MM_LOWMETRIC      (mm exact, max. 3200 mm, Grsse fest)

'Flag2:
'bei Flag2=1,2 nach Clipboard kopieren
'bei Flag2=2 wird Clipboard (auch Text !) gelscht


End Sub

Sub MArc (x, y, r, alfa1!, alfa2!, Pic As Control)

If Mflag = 0 Then
  Pic.Circle (x, y), r, , alfa1!, alfa2!
ElseIf Mflag = 1 Then
  MSetPen Pic
  Printer.Circle (x, y), r, , alfa1!, alfa2!
ElseIf Mflag = 2 Then
  MSetPen Pic
  MetaArc1 x, y, r, alfa1!, alfa2!

End If
End Sub

Sub MCircle (x, y, r, Pic As Control)
If Mflag = 0 Then
  Pic.Circle (x, y), r
ElseIf Mflag = 1 Then
  MSetPen Pic
  Printer.Circle (x, y), r
ElseIf Mflag = 2 Then
  MSetPen Pic
  MetaCircle x, y, r
End If

End Sub

Sub mEllipse (mx, my, a, B, phi, n%, Pic As Control)
'Ellipse mit MLine gezeichnet
'mx,my  Zentrum
'a,b    xRadius,yRadius
'phi    Neigungswinkel

Dim i  As Integer

Const PI = 3.141592

p = 2 * PI / (n% - 1)
c1 = Cos(phi * PI / 180)
s1 = Sin(phi * PI / 180)

c2 = Cos(p)
s2 = Sin(p)
c3 = 1
s3 = 0

x1 = mx + a * c3 * c1 - b1 * s1 * s3
y1 = my + a * s1 * c3 + B * s2 * s3

For i = 1 To n%
  xh = a * c3
  yh = B * s3
  x = mx + xh * c1 - yh * s1
  y = my + xh * s1 + yh * c1
  'Pic.Line (x1, y1)-(x, y)
  MLine x1, y1, x, y, Pic
  x1 = x
  y1 = y
  p = c3 * c2 - s3 * s2
  s3 = s3 * c2 + c3 * s2
  c3 = p
Next i

End Sub

Sub MFloodFill (x1, y1, AreaColor As Long, Pic As Control)
'AreaColor=Farbe der zu fllenden Flche
'Es wird gefllt bis eine andere Farbe getroffen wird

PixPerMx = Int(((Pic.Width / Pic.ScaleWidth) / Screen.TwipsPerPixelX) * 1000)
PixPerMy = Int(((Pic.Height / Pic.ScaleHeight) / Screen.TwipsPerPixelY) * 1000)


MSetPen Pic

If Mflag = 0 Then
     'Floodfill auf dem Bildschirm in Pixel-Koordinaten !
     PixPerMx = Int(((Pic.Width / Pic.ScaleWidth) / Screen.TwipsPerPixelX) * 1000)
     PixPerMy = Int(((Pic.Height / Pic.ScaleHeight) / Screen.TwipsPerPixelY) * 1000)
     a = ExtFloodFill(Pic.hDC, Int(x1 * PixPerMx / 1000), Int(y1 * PixPerMy / 1000), AreaColor, 1)
     'a = FloodFill(Pic.hDC, Int(x1 * PixPerMx / 1000), Int(y1 * PixPerMy / 1000), 1)
ElseIf Mflag = 1 Then
     'Floodfill auf den Printer in Pixel-Koordinaten ! Funkt. nicht!
     'PixPerMx = Int(((Printer.Width / Printer.ScaleWidth) / Screen.TwipsPerPixelX) * 1000)
     'PixPerMy = Int(((Printer.Height / Printer.ScaleHeight) / Screen.TwipsPerPixelY) * 1000)
     'a = ExtFloodFill(Printer.hDC, Int(x1 * PixPerMx / 1000), Int(y1 * PixPerMy / 1000), AreaColor, 1)
     


ElseIf Mflag = 2 Then
     
    'a = ExtFloodFill(Pic.hDC, Int(x1 * PixelPerMx / 1000), Int(y1 * PixelPerMy / 1000), 0, 0)
    MetaFloodFill x1, y1, AreaColor
End If

End Sub

Sub MInitFont (Picture1 As Control, Picture2 As Control, Angle As Integer, hfont As Integer, HoldFont As Integer)
'Font in Picture2 wie in Picture1 setzen

Dim Font As LOGFONT

'Get Info about Picture font
szFaceName$ = Space$(80)
retval% = GetTextFace(Picture1.hDC, 79, szFaceName$)


Dim lpMetrics As Textmetric
B% = GetTextMetrics(Picture1.hDC, lpMetrics)

Font.lfHeight = lpMetrics.tmHeight
Font.lfWidth = 0 '-- let Windows figure out the appropriate width based on the height
Font.lfEscapement = Angle * 10 '-- rotate 270 degrees (bottom to top)
Font.lfOrientation = 0  '-- normal character orientation (straight up)
Font.lfPitchAndFamily = lpMetrics.tmPitchandFamily 'Chr$(33)
Font.lfCharSet = lpMetrics.tmCharset 'Chr$(OEM_CHARSET)  '-- this is important!
Font.lfQuality = Chr$(2)
Font.lfWeight = lpMetrics.tmWeight '400
Font.lfItalic = lpMetrics.tmItalic
Font.lfUnderline = lpMetrics.tmUnderlined
Font.lfStrikeOut = lpMetrics.tmStruckOut
Font.lfOutPrecision = Chr$(2) 'Chr$(0)
Font.lfClipPrecision = Chr$(0)
Font.lfFaceName = szFaceName$ + Chr$(0)

'-- get the handle to the font we specify
If hfont Then ok% = DeleteObject(hfont)
hfont = CreateFontIndirect(Font)

'-- now let's select it to our current Printer hDC
HoldFont = SelectObject(Picture2.hDC, hfont)

End Sub

Sub MLine (x1, y1, x2, y2, Pic As Control)

If Mflag = 0 Then
  Pic.Line (x1, y1)-(x2, y2)
ElseIf Mflag = 1 Then
  MSetPen Pic
  Printer.Line (x1, y1)-(x2, y2)
ElseIf Mflag = 2 Then
  MSetPen Pic
  Metaline x1, y1, x2, y2
End If

End Sub

Sub MPoint (x, y, Color&, Pic As Control)
If Mflag = 0 Then
  Pic.PSet (x, y), Color&
 ElseIf Mflag = 1 Then
  MSetPen Pic
  Printer.PSet (x, y), Color&
 ElseIf Mflag = 2 Then
  MetaSetPoint x, y, Color&
 End If

End Sub

Sub MPrint (x!, y!, text As String, Pic As Control)
'horizontaler Text

If Mflag = 0 Then
  Pic.CurrentX = x!
  Pic.CurrentY = y!
  Pic.Print text
ElseIf Mflag = 1 Then
  PrinterInitFont Pic, 0, 0
  Printer.CurrentX = x!
  Printer.CurrentY = y!
  Printer.Print text$
  PrinterRestoreFont
 
ElseIf Mflag = 2 Then
  MetaInitFont Pic, 0, 0
  MSetPen Pic
  MetaText x!, y!, text
  
End If

End Sub

Sub MPrintS (x!, y!, text As String, Angle As Integer, Alignmentflag As Integer, Pic As Control)
'Text in beliebigem Winkel und Alignment
'AlignmentFlag:     0 = Default  (left, top)
'                   2 = RIGHT
'                   6 = CENTER
'                   8 = BOTTOM
'                  18 = BASELINE
'   (kann OR-verknpft werden)


If Mflag = 0 Then   'Pic
 If Angle Or Alignmentflag Then
     PrintS x!, y!, text, Angle, Alignmentflag, Pic
 Else
     MPrint x!, y!, text, Pic
 End If

ElseIf Mflag = 1 Then  'Printer
  MSetPen Pic
  PrinterInitFont Pic, Angle, Alignmentflag
  Printer.CurrentX = x!
  Printer.CurrentY = y!
  Printer.Print text$
  PrinterRestoreFont
 
  
ElseIf Mflag = 2 Then
  MetaInitFont Pic, Angle, Alignmentflag
  MSetPen Pic
  MetaText x!, y!, text
  
End If


End Sub

Sub MRect (x1, y1, x2, y2, Pic As Control)

 If Mflag = 0 Then
  Pic.Line (x1, y1)-(x2, y2), , B
 ElseIf Mflag = 1 Then
  MSetPen Pic
  Printer.Line (x1, y1)-(x2, y2), , B
 ElseIf Mflag = 2 Then
  MSetPen Pic
  MetaRect x1, y1, x2, y2
 End If



End Sub

Sub MSetFontAngleAndAlign (Pic As Control, Angle%, Alignmentflag%)
'Winkel u. Alignment in Pic setzen
'AlignmentFlag:     0 = Default  (left, top)
'                   2 = RIGHT
'                   6 = CENTER
'                   8 = BOTTOM
'                  18 = BASELINE
'   (kann OR-verknpft werden)

Dim Font As LOGFONT

'Get Info about Pic font
szFaceName$ = Space$(80)
retval% = GetTextFace(Pic.hDC, 79, szFaceName$)


Dim lpMetrics As Textmetric
B% = GetTextMetrics(Pic.hDC, lpMetrics)

Font.lfHeight = lpMetrics.tmHeight
Font.lfWidth = 0 '-- let Windows figure out the appropriate width based on the height
Font.lfEscapement = Angle * 10
Font.lfOrientation = 0  '-- normal character orientation (straight up)
Font.lfPitchAndFamily = lpMetrics.tmPitchandFamily
Font.lfCharSet = lpMetrics.tmCharset
Font.lfQuality = Chr$(2)
Font.lfWeight = lpMetrics.tmWeight
Font.lfItalic = lpMetrics.tmItalic
Font.lfUnderline = lpMetrics.tmUnderlined
Font.lfStrikeOut = lpMetrics.tmStruckOut
Font.lfOutPrecision = Chr$(2)
Font.lfClipPrecision = Chr$(0)
Font.lfFaceName = szFaceName$ + Chr$(0)

'-- get the handle to the font we specify
If hfont Then ok% = DeleteObject(hfont)
hfont = CreateFontIndirect(Font)

'-- now let's select it to our current  hDC
HoldFont% = SelectObject(Pic.hDC, hfont)
Holdalign% = SetTextAlign(Pic.hDC, Alignmentflag%)

End Sub

Sub MsetOutput (Flag%, Pic As Control)
'Ausgabe festlegen:
'0 = Bildschirm
'1 = Printer
'2 = Clipboard

Mflag = Flag%

If Mflag = 1 Then   'Printer
   Printer.ScaleMode = Pic.ScaleMode
   'Printer.FontName = Pic.FontName
   Printer.FontSize = Pic.FontSize
ElseIf Mflag = 2 Then
   
   
End If
End Sub

Sub MSetPen (Pic As Control)
'Farbe, Stil und Breite fr Metafile und Printer
'wie in Pic setzen

  PCol& = Pic.ForeColor
  PWidth% = Pic.DrawWidth
  PStyle% = Pic.DrawStyle
  
  If Monochrome Then PCol& = 0
  If PStyle% Then PWidth% = 0

If Mflag = 1 Then
  Printer.DrawWidth = PWidth% + 1
  Printer.DrawStyle = PStyle%
  Printer.ForeColor = PCol&
  Printer.FillStyle = Pic.FillStyle
  Printer.FillColor = Pic.FillColor
ElseIf Mflag = 2 Then
  MetaSetPen PCol&, PWidth%, PStyle%
  MetaSetBrush CLng(Pic.FillColor), CInt(Pic.FillStyle)
End If

End Sub

Sub PrinterInitFont (Pic As Control, Angle As Integer, Alignmentflag As Integer)
'Printerfont wie in Pic setzen , aber mit Angle u. Alignmentflag

Dim Font As LOGFONT

'Get Info about Pic font
szFaceName$ = Space$(80)
retval% = GetTextFace(Pic.hDC, 79, szFaceName$)


Dim lpMetrics As Textmetric
B% = GetTextMetrics(Pic.hDC, lpMetrics)

Font.lfHeight = lpMetrics.tmHeight / .351
Font.lfWidth = 0 '-- let Windows figure out the appropriate width based on the height
Font.lfEscapement = Angle * 10
Font.lfOrientation = 0  '-- normal character orientation (straight up)
Font.lfPitchAndFamily = lpMetrics.tmPitchandFamily
Font.lfCharSet = lpMetrics.tmCharset
Font.lfQuality = Chr$(2)
Font.lfWeight = lpMetrics.tmWeight
Font.lfItalic = lpMetrics.tmItalic
Font.lfUnderline = lpMetrics.tmUnderlined
Font.lfStrikeOut = lpMetrics.tmStruckOut
Font.lfOutPrecision = Chr$(2)
Font.lfClipPrecision = Chr$(0)
Font.lfFaceName = szFaceName$ + Chr$(0)

'-- get the handle to the font we specify
If PrinterHfont Then ok% = DeleteObject(PrinterHfont)
PrinterHfont = CreateFontIndirect(Font)

'-- now let's select it to our current  hDC
PrinterHoldFont% = SelectObject(Printer.hDC, PrinterHfont)
PrinterHoldalign% = SetTextAlign(Printer.hDC, Alignmentflag%)

End Sub

Sub PrinterRestoreFont ()

ok% = DeleteObject(PrinterHfont)
a% = SelectObject(Printer.hDC, PrinterHoldFont%)
Align% = SetTextAlign(Printer.hDC, PrinterHoldalign%)

End Sub

Sub PrintS (x!, y!, text$, Angle As Integer, Alignmentflag As Integer, Pic As Control)
'Text in beliebigem Winkel in Picturebox schreiben
'AlignmentFlag:     0 = Default  (left, top)
'                   2 = RIGHT
'                   6 = CENTER
'                   8 = BOTTOM
'                  18 = BASELINE
'   (kann OR-verknpft werden)



MSetFontAngleAndAlign Pic, Angle, Alignmentflag
Pic.CurrentX = x!
Pic.CurrentY = y!
Pic.Print text$

RestoreFont Pic



End Sub

Sub RestoreFont (Pic As Control)
'alten Font wiederherstellen

ok% = DeleteObject(hfont)
a% = SelectObject(Pic.hDC, HoldFont%)
Align% = SetTextAlign(Pic.hDC, Holdalign%)

End Sub

Sub SetMonoChromeOutPut (MonoFlag%)
'MonoChrome Ausgabe setzen
Monochrome = MonoFlag%
End Sub

